package com.extensibility.validation;

import com.extensibility.xml.SchemaIntf;
import com.extensibility.xml.dt.DataType;
import com.extensibility.xml.dt.DataTypeIntf;

class DoubleLeafValidator extends DataValidator {
   String validate(SchemaIntf var1, DataType var2, String var3) {
      double var4;
      if (var3.equals("INF")) {
         var4 = Double.POSITIVE_INFINITY;
      } else if (var3.equals("-INF")) {
         var4 = Double.NEGATIVE_INFINITY;
      } else if (var3.equals("NaN")) {
         var4 = Double.NaN;
      } else {
         try {
            var4 = Double.valueOf(var3);
         } catch (Exception var8) {
            String var7 = "invalid number";
            return var7;
         }

         if (var2.getTypeName() == DataTypeIntf.R4 && (var4 < (double)Float.MIN_VALUE || var4 > (double)Float.MAX_VALUE)) {
            return String.valueOf(String.valueOf(String.valueOf("value ").concat(String.valueOf(var4))).concat(String.valueOf(" is out of range for type "))).concat(String.valueOf(var2.getTypeName()));
         }
      }

      String var6 = ((DataValidator)this).applyDoubleFacets(var1, var2, var4);
      if (var6 == null) {
         var6 = ((DataValidator)this).applyLexicalFacets(var1, var2, var3);
      }

      return var6;
   }
}
