package com.extensibility.validation;

import com.extensibility.xml.SchemaIntf;
import com.extensibility.xml.dt.DataType;
import com.extensibility.xml.dt.DataTypeIntf;
import java.math.BigInteger;

class IntegralLeafValidator extends DataValidator {
   BigInteger min;
   BigInteger max;
   BigInteger zero = new BigInteger("0");
   BigInteger minS1 = new BigInteger("-80", 16);
   BigInteger maxS1 = new BigInteger("7F", 16);
   BigInteger maxU1 = new BigInteger("FF", 16);
   BigInteger minS2 = new BigInteger("-8000", 16);
   BigInteger maxS2 = new BigInteger("7FFF", 16);
   BigInteger maxU2 = new BigInteger("FFFF", 16);
   BigInteger minS4 = new BigInteger("-80000000", 16);
   BigInteger maxS4 = new BigInteger("7FFFFFFF", 16);
   BigInteger maxU4 = new BigInteger("FFFFFFFF", 16);
   BigInteger minS8 = new BigInteger("-8000000000000000", 16);
   BigInteger maxS8 = new BigInteger("7FFFFFFFFFFFFFFF", 16);
   BigInteger maxU8 = new BigInteger("FFFFFFFFFFFFFFFF", 16);

   String validate(SchemaIntf var1, DataType var2, String var3) {
      if (var3.startsWith("+") && !var3.startsWith("+-")) {
         var3 = var3.substring(1);
      }

      BigInteger var4;
      try {
         var4 = new BigInteger(var3);
      } catch (NumberFormatException var7) {
         String var6 = "invalid integer";
         return var6;
      }

      this.min = null;
      this.max = null;
      if (var2.getTypeName() == DataTypeIntf.I1) {
         this.min = this.minS1;
         this.max = this.maxS1;
      } else if (var2.getTypeName() == DataTypeIntf.UI1) {
         this.min = this.zero;
         this.max = this.maxU1;
      } else if (var2.getTypeName() == DataTypeIntf.I2) {
         this.min = this.minS2;
         this.max = this.maxS2;
      } else if (var2.getTypeName() == DataTypeIntf.UI2) {
         this.min = this.zero;
         this.max = this.maxU2;
      } else if (var2.getTypeName() == DataTypeIntf.I4) {
         this.min = this.minS4;
         this.max = this.maxS4;
      } else if (var2.getTypeName() == DataTypeIntf.UI4) {
         this.min = this.zero;
         this.max = this.maxU4;
      } else if (var2.getTypeName() == DataTypeIntf.I8) {
         this.min = this.minS8;
         this.max = this.maxS8;
      } else if (var2.getTypeName() == DataTypeIntf.UI8) {
         this.min = this.zero;
         this.max = this.maxU8;
      }

      return this.min == null || var4.compareTo(this.min) >= 0 && var4.compareTo(this.max) <= 0 ? ((DataValidator)this).applyIntegralFacets(var1, var2, var4) : String.valueOf("value out of range for type ").concat(String.valueOf(var2.getTypeName()));
   }
}
