package com.extensibility.validation;

import org.w3c.dom.Attr;
import org.w3c.dom.CharacterData;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.ProcessingInstruction;

public final class ValidatorError {
   protected Object errorLocation;
   protected Node offendingNode;
   protected Node ownerNode;
   protected String message;
   protected int errorColumn;

   public ValidatorError() {
   }

   public ValidatorError(Element var1, Node var2, String var3) {
      this.errorLocation = var1;
      this.offendingNode = var2;
      this.message = var3;
   }

   public ValidatorError(Attr var1, Node var2, String var3) {
      this.errorLocation = var1;
      this.ownerNode = var2;
      this.message = var3;
   }

   public ValidatorError(CharacterData var1, String var2) {
      this.errorLocation = var1;
      this.message = var2;
   }

   public ValidatorError(ProcessingInstruction var1, String var2) {
      this.errorLocation = var1;
      this.message = var2;
   }

   public ValidatorError(int var1, int var2, String var3) {
      this.errorLocation = new Integer(var1);
      this.errorColumn = var2;
      this.message = var3;
   }

   public ValidatorError(String var1) {
      this.errorLocation = new Integer(0);
      this.errorColumn = 0;
      this.message = var1;
   }

   public Object getErrorLocation() {
      return this.errorLocation;
   }

   public int getErrorLine() {
      byte var1 = 0;

      try {
         int var2 = (Integer)this.errorLocation;
         return var2;
      } catch (ClassCastException var4) {
         return var1;
      }
   }

   public int getErrorColumn() {
      return this.errorColumn;
   }

   public Node getErrorNode() {
      try {
         Node var1 = (Node)this.errorLocation;
         return var1;
      } catch (ClassCastException var3) {
         Object var2 = null;
         return (Node)var2;
      }
   }

   public Node getOffendingNode() {
      return this.offendingNode;
   }

   public Node getOwnerNode() {
      return this.ownerNode;
   }

   public String getMessage() {
      return this.message;
   }

   public String toString() {
      return this.message;
   }
}
